poj 2429 GCD LCM Inverse

2024-02-08 01:38
文章标签 poj gcd inverse lcm 2429

本文主要是介绍poj 2429 GCD LCM Inverse,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

http://poj.org/problem?id=2429

这题能1A感觉很好!Pollard_Rho 很神奇呀,能把这么大的数分解成素因子,然后dfs 找到其 ,lcm/gcd 的所有的因子就行了,取最优的答案


#include<iostream>
#include<cstdio>
#include<ctime>
#include<cstring>
#include<cstdlib>
#include<algorithm>#define C 240
#define TIME 10
#define LL unsigned long long
using namespace std;
int cnt;
LL ans;
LL prime[1010],a,b;LL gcd(LL a, LL b)
{if(a==0) return 1;if(a<0) return gcd(-a,b);return b==0?a:gcd(b,a%b);
}
LL MultMod(LL a,LL b,LL n)
{a%=n;b%=n;LL ret=0;while(b){if(b&1){ret+=a;if(ret>=n) ret-=n;}a=a<<1;if(a>=n) a-=n;b=b>>1;}return ret;
}
LL PowMod(LL a,LL n,LL m)
{LL ret=1;a=a%m;while(n>=1){if(n&1)ret=MultMod(ret,a,m);a=MultMod(a,a,m);n=n>>1;}return ret;
}
bool Witness(LL a,LL n)
{LL t=0,u=n-1;while(!(u&1)){t++;u/=2;}LL x0=PowMod(a,u,n);for(int i=1; i<=t; i++){LL x1=MultMod(x0,x0,n);if(x1==1&&x0!=1&&x0!=(n-1))return true;x0=x1;}if(x0!=1)return true;return false;
}
bool Miller_Rabin(LL n,int t)
{if(n==2) return true;if((n&1)==0)  return false;srand(time(NULL));for(int i=0; i<t; i++){LL a=rand()%(n-1)+1;if(Witness(a,n))return false;}return true;
}
LL Pollard_Rho(LL n,LL c)
{LL i=1,x=rand()%n,y=x,k=2;while(1){i++;x=(MultMod(x,x,n)+c)%n;LL d=gcd(y-x,n);if(d!=1&&d!=n)return d;if(x==y)return n;if(i==k){y=x;k*=2;}}
}
void get_small(LL n,LL c)
{if(n==1) return;if(Miller_Rabin(n,TIME)){prime[cnt++]=n;return;}LL p=n;while(p>=n) p=Pollard_Rho(p,c--);get_small(p,c);get_small(n/p,c);
}
LL factor[20],ans1,ans2;
int fac_n;void dfs(int id,LL mul)
{//cout<<id<<" "<<mul<<endl;if(id==fac_n){if(ans1==-1||ans1+ans2 > a*mul+b/mul)  ans1=a*mul,ans2=b/mul;if(ans1>ans2) swap(ans1,ans2);return;}dfs(id+1,mul*factor[id]);dfs(id+1,mul);
}
int main()
{while(scanf("%llu %llu",&a,&b)==2){cnt=0;get_small(b/a,C);sort(prime,prime+cnt);/*for(int i=0;i<cnt;i++)cout<<prime[i]<<" ";cout<<endl;*/fac_n=0;for(int i=0;i<cnt;i++){factor[fac_n]=prime[i];while(i<cnt-1&&prime[i]==prime[i+1]) factor[fac_n]*=prime[i++];fac_n++;}/* for(int i=0;i<fac_n;i++)cout<<factor[i]<<" ";cout<<endl;*/ans1=-1,ans2=-1;dfs(0,1);printf("%llu %llu\n",ans1,ans2);}return 0;
}
//3 60


这篇关于poj 2429 GCD LCM Inverse的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/689552

相关文章

poj 3974 and hdu 3068 最长回文串的O(n)解法(Manacher算法)

求一段字符串中的最长回文串。 因为数据量比较大,用原来的O(n^2)会爆。 小白上的O(n^2)解法代码:TLE啦~ #include<stdio.h>#include<string.h>const int Maxn = 1000000;char s[Maxn];int main(){char e[] = {"END"};while(scanf("%s", s) != EO

hdu 2602 and poj 3624(01背包)

01背包的模板题。 hdu2602代码: #include<stdio.h>#include<string.h>const int MaxN = 1001;int max(int a, int b){return a > b ? a : b;}int w[MaxN];int v[MaxN];int dp[MaxN];int main(){int T;int N, V;s

poj 1511 Invitation Cards(spfa最短路)

题意是给你点与点之间的距离,求来回到点1的最短路中的边权和。 因为边很大,不能用原来的dijkstra什么的,所以用spfa来做。并且注意要用long long int 来存储。 稍微改了一下学长的模板。 stack stl 实现代码: #include<stdio.h>#include<stack>using namespace std;const int M

poj 3259 uva 558 Wormholes(bellman最短路负权回路判断)

poj 3259: 题意:John的农场里n块地,m条路连接两块地,w个虫洞,虫洞是一条单向路,不但会把你传送到目的地,而且时间会倒退Ts。 任务是求你会不会在从某块地出发后又回来,看到了离开之前的自己。 判断树中是否存在负权回路就ok了。 bellman代码: #include<stdio.h>const int MaxN = 501;//农场数const int

poj 1258 Agri-Net(最小生成树模板代码)

感觉用这题来当模板更适合。 题意就是给你邻接矩阵求最小生成树啦。~ prim代码:效率很高。172k...0ms。 #include<stdio.h>#include<algorithm>using namespace std;const int MaxN = 101;const int INF = 0x3f3f3f3f;int g[MaxN][MaxN];int n

poj 1287 Networking(prim or kruscal最小生成树)

题意给你点与点间距离,求最小生成树。 注意点是,两点之间可能有不同的路,输入的时候选择最小的,和之前有道最短路WA的题目类似。 prim代码: #include<stdio.h>const int MaxN = 51;const int INF = 0x3f3f3f3f;int g[MaxN][MaxN];int P;int prim(){bool vis[MaxN];

poj 2349 Arctic Network uva 10369(prim or kruscal最小生成树)

题目很麻烦,因为不熟悉最小生成树的算法调试了好久。 感觉网上的题目解释都没说得很清楚,不适合新手。自己写一个。 题意:给你点的坐标,然后两点间可以有两种方式来通信:第一种是卫星通信,第二种是无线电通信。 卫星通信:任何两个有卫星频道的点间都可以直接建立连接,与点间的距离无关; 无线电通信:两个点之间的距离不能超过D,无线电收发器的功率越大,D越大,越昂贵。 计算无线电收发器D

poj 1502 MPI Maelstrom(单源最短路dijkstra)

题目真是长得头疼,好多生词,给跪。 没啥好说的,英语大水逼。 借助字典尝试翻译了一下,水逼直译求不喷 Description: BIT他们的超级计算机最近交货了。(定语秀了一堆词汇那就省略吧再见) Valentine McKee的研究顾问Jack Swigert,要她来测试一下这个系统。 Valentine告诉Swigert:“因为阿波罗是一个分布式共享内存的机器,所以它的内存访问

uva 10061 How many zero's and how many digits ?(不同进制阶乘末尾几个0)+poj 1401

题意是求在base进制下的 n!的结果有几位数,末尾有几个0。 想起刚开始的时候做的一道10进制下的n阶乘末尾有几个零,以及之前有做过的一道n阶乘的位数。 当时都是在10进制下的。 10进制下的做法是: 1. n阶位数:直接 lg(n!)就是得数的位数。 2. n阶末尾0的个数:由于2 * 5 将会在得数中以0的形式存在,所以计算2或者计算5,由于因子中出现5必然出现2,所以直接一

poj 3159 (spfa差分约束最短路) poj 1201

poj 3159: 题意: 每次给出b比a多不多于c个糖果,求n最多比1多多少个糖果。 解析: 差分约束。 这个博客讲差分约束讲的比较好: http://www.cnblogs.com/void/archive/2011/08/26/2153928.html 套个spfa。 代码: #include <iostream>#include <cstdio>#i